import AccessControl
import OFS, Globals
from OFS import SimpleItem
import types
from TraversableWrapper import Traversable
from Globals import Persistent
from AccessControl import ClassSecurityInfo
from Cruft import Cruft
from common import add_dtml

class TestiYlesanne(
     Persistent,
     OFS.SimpleItem.Item,
     Traversable,
     AccessControl.Role.RoleManager
     ):
     "Testi lesanne"
     meta_type="TestiYlesanne"
     kysimus="lesande ksimus"
     vastusPakutud=0
     ylesanneteTyybid=("ValikYlesanne","TekstivastusegaYlesanne", "YksikvalikYlesanne")
     def punkte(self):
        "Arvestatavate punktide arv"
        return 0
        
     def maxPunkte(self):
        "Vimalik maksimumpunktide arv vastavas lesandes"
        return 0
        
     def kasPunktiArvutus(self):
        "Kas vastav lesanne on punktiarvutuse osa"
        return 0
        
     def kysimusHTML(self):
        "Ksimus HTML-kodeeritult"
        return asendaHTML(self.kysimus)
        
     def taitmineHTML(self, elemendinimi):
        "Vastuse sisestamise koht"
        return "Titmiseks meldud osa"
        
     def vaatamineHTML(self):
        "Koostaja poolt lahenduskoha vaatamine"
        return "Variantide vaatamiseks meldud osa"


     def kasPihtasArvutus(self):
       "Kas uuritakse tabamust"
       return 0

     def kasPihtasHTML(self):
        "Kas saadi vastusega pihta"
        if self.kasPihtasArvutus():
           if self.kasPihtas():
              return "+"
           else:
              return "-"
        else:
           return "Tabamust ei uurita"

     def kasPihtas(self):
        "Sisemine uuring alamklassis"
        return 0
        
     def tegelikHTML(self):
        "Opetaja pakutud oige vastus"
        return "Ainuoige lahendus puudub"
        
     def kysimusVormis(self, elemendiNimi="kysimus"):
        return """<input type="text" name="%s" value="%s" />"""  % (elemendiNimi, self.kysimusHTML())
        
     def vastuseMuutmisVorm(self):
        "Muutmisvormi elemendid vastusepoole andmete nitamiseks, soovitav le katta, elemendi nimeks vastus"
        return "Vastamiskoht"

     def leivaPuru(self, viimane=0):
        "Teekond les"
        nimi=self.id
        if viimane:
          tekst=self.id
        else:
          tekst="<a href='"+self.absolute_url()+"'>"+str(self.id)+"</a>"
        return self.aq_parent.leivaPuru()+" &gt; "+tekst

     def muutmisVorm(self, REQUEST):
        "Testi muutmiseks meldud leht, le katta vaid juhul, kui vaja muuta enam kui he elemendinimega vastuseosa"
        tulemus=leheAlgus(self, REQUEST)+"<form action='muutmisLeht'><table><tr>"+\
          "<td>"+self.kysimusVormis()+"</td>"+\
          "<td>"+self.vastuseMuutmisVorm()+"</td></tr>"+\
          "<tr><td colspan='2' align='center'><input type='submit' value='Salvesta' /></td></tr>"+\
          "</table></form>"
        return tulemus
        
     def muutmisLeht(self, REQUEST, kysimus=None, vastus=None):
        "Muutmisvormi andmete pdja"
        if kysimus:
          self.kysimus=kysimus
        self.vastuseMuutmisLeht(vastus)
        REQUEST.RESPONSE.redirect('muutmisVorm')
        
        
     def vastuseMuutmisLeht(self, vastus):
        "Leht vastuse muutmiseks, soovitav le katta"   
        pass
        
     def index_html(self, REQUEST):
        "Peegel veebis"
        return leheAlgus(self, REQUEST)+\
         "<table><tr><td>"+self.kysimusHTML()+"</td>"+\
           "<td>"+self.vaatamineHTML()+"</td></tr></table>"
        
     def kustuta(self):
        "lesanne kustutatakse"
        self.aq_parent._delObject(self.id)
        
    # def koopia(self):
    #    "Samade andmetega lesanne"
    #    ty=TestiYlesanne()
    #    ty.kysimus=self.kysimus
    #    return ty
        
     def ylesanneteTyypideLoetelu(self):
        "Viited lesannete tpidele"
        tulemus="<h3>&Uuml;lesannete t&uuml;&uuml;bi valimine</h3>"
        for x in self.ylesanneteTyybid:
          tulemus=tulemus+"\n"+\
            ("<a href='lisaUusYlesanne?tyyp=%s'>%s</a><br />" %  (x, x))
        return tulemus
        
     def lisaUusYlesanne(self, tyyp):
        "lesande uus eksemplar"
        if tyyp=='ValikYlesanne':
          return ValikYlesanne('Kas konnad ujuvad')
        if tyyp=='TekstivastusegaYlesanne':
          return TekstivastusegaYlesanne('Kirjelda konnade ujumist')
        if tyyp=='YksikvalikYlesanne':
          return YksikvalikYlesanne('Kuidas konnad ujuvad')
          
     def salvestaPakutu(self, andmed):
       "Loob koopia lesandest koos pakutud vastusega"
       k=self.koopia()
       k.vastusPakutud=1
       k.pakutudAndmed=andmed
       return k
        
        
     

     
        
class YlesandeKirjeldus(
     Persistent,
     OFS.SimpleItem.Item,
     Traversable,
     AccessControl.Role.RoleManager
     ):
     "Testi lesande metadata"
     meta_type="YlesandeKirjeldus"
     marksonad=[]
     selgitus=""
     def kasLeidubMarksona(self, sona):
        "1, kui vastav mrksna olemas"
        return sona in self.marksonad
        
     def lisaMarksona(self, sona):
        "Kui mrksna puudub, siis lisatakse"
        if not self.kasLeidubMarksona(sona):
           self.marksonad.append(sona)
           
     def leivaPuru(self, viimane=0):
        "Teekond les"
        return self.aq_parent.leivaPuru()+" &gt; kirjeldus"
           
     def muutmisVorm(self, REQUEST):
        "Vorm kirjelduse muutmiseks"
        tulemus=leheAlgus(self, REQUEST)+"<form action='muutmisLeht'><table><tr><td>Selgitus:</td>"+\
          ("<td><input type='text' name='selgitus' value='%s' /></td></tr>" % self.selgitus)
        for x in self.marksonad:
          tulemus=tulemus+"\n<tr><td>Marksona</td><td>"+\
             ("<input type='text' name='marksona' value='%s'/></td></tr>" % x)
        tulemus=tulemus+"\n<tr><td>Marksona</td><td>"+\
          ("<input type='text' name='marksona' value=''/></td></tr>")+\
          "<tr><td colspan='2' align='center'><input type='submit' value='Salvesta' /></td></tr></table></form>"
        return tulemus
        
     def muutmisLeht(self, REQUEST, selgitus, marksona):
        "Muutuste salvestus"
        self.selgitus=selgitus
        if type(marksona) is None:
           marksona=()
        if type(marksona) is types.StringType:
           marksona=(marksona,)
        self.marksonad=[]
        for x in marksona:
           if x.strip():
             self.lisaMarksona(x)
        REQUEST.RESPONSE.redirect('muutmisVorm')
           
     def index_html(self):
        "Veebi nha olev osa"
        return self.selgitus+" "+str(self.marksonad)
           
        
     
class YlesanneKoosKirjeldusega(
     OFS.Folder.Folder,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
     "Hoiab lesande oma kirjeldusega koos"
     def __init__(self, ylesanne, kirjeldus=YlesandeKirjeldus()):
        self._setObject('ylesanne', ylesanne)
        self._setObject('kirjeldus', kirjeldus)
        
     def lisaMarksona(self, sona):
        "Lisab kirjelduse alla sealt puuduva mrksna"
        self.kirjeldus.lisaMarksona(sona)
        
     def marksonadHTML(self):
        "Mrksnad jadana"
        return asendaHTML(str(self.kirjeldus.marksonad))
        
     def selgitusHTML(self):
        "Selgitus"
        return asendaHTML(self.kirjeldus.selgitus)
        
     def leivaPuru(self, viimane=0):
       "Teekond les"
       nimi=self.id
       if viimane:
         tekst=nimi
       else:
         tekst="<a href='"+self.absolute_url()+"'">nimi+"</a>"
       return self.aq_parent().leivaPuru()+ " &gt; Kirjeldusega lesanne " + tekst        
        
     def index_html(self):
        "Peegel veebis"
        return self.ylesanne.kysimusHTML() + self.marksonadHTML()+self.selgitusHTML()
        
        
     
     
class TestiYlesanneteHoidla(
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft):
     "Hoidla petaja tarvis"
     #elemendid=[]
     nr=0
     
     def elemendidHoidlas(self):
        "Hoidlas olevad lesanded koos kirjeldustega"
        return self.objectValues()

     def kasYlesannePuudub(self, ylesanne):
        "1 kui vastavate vljadega lesanne puudub"
        return ylesanne not in self.ylesandedHoidlas()
     
     def lisaYlesanneKoosKirjeldusega(self, element):
        "lesanne lisatakse puudumise korral"
        if self.kasYlesannePuudub(element.ylesanne):
           self.nr=self.nr+1
           element.id='el'+str(self.nr)
           self._setObject(element.id, element)
           #elemendid.append(element)
        
     def lisaYlesanne(self, ylesanne):
        "Vaid lesande lisamine, kirjeldus thi"
        self.lisaYlesanneKoosKirjeldusega(YlesanneKoosKirjeldusega(ylesanne))
     
     
     def ylesandedHoidlas(self):
        "Hoidlast vaid lesanded, mitte kirjeldused."
        return [x.ylesanne for x in self.elemendidHoidlas()]
        
     
     def marksonadHoidlas(self):
        "Mrksnad kikide lesannete peale kokku"
        marksonad=[]
        for x in self.elemendidHoidlas():
          if x.kirjeldus:
            for k in x.kirjeldus.marksonad:
              if k not in marksonad:
                marksonad.append(k)
        return marksonad
        
     def marksonaViideteLoetelu(self, REQUEST):
        "Viited leiduvatele mrksnadele"
        m=self.marksonadHoidlas()
        #m.sort()
        if m is None:
          return "Thi mrksnastik"
        tulemus=leheAlgus(self, REQUEST)+"<h3>Marksonad</h3>"
        for x in m:
          tulemus=tulemus+"\n"+\
            "<a href='ylesandedTabelina?marksona="+x+"'>"+x+"</a><br />"
        return tulemus

     def kasLeidubMarksona(self, sona):
        "Kas vastav mrksna hoidlas olemas"
        return sona in self.marksonadHoidlas()
        
     def marksonaleVastavadElemendid(self):
        "Vaid soovitud mrksnaga elemendid"
        elemendid=[]
        for x in self.ylesandedHoidlas():
          if sona in x.kirjedus.marksonad:
             elemendid.append(x)
        return elemendid


     def lisaYlesandedTestist(self, test):
        "Lisatakse vaid kordumatud lesanded"
        for x in test.ylesanded():
           self.lisaYlesanne(x)
           
     def ylesandedTabelina(self, REQUEST, marksona=None):
        "lesanded ja nende kirjeldused tutvustava tabelina"
        if marksona is None:
          m=self.elemendidHoidlas()
        else:
          m=self.marksonaleVastavadElemendid(marksona)
        tulemus=leheAlgus(self, REQUEST)+"<table>"
        for x in m:
          tulemus=tulemus+"\n<tr><td>"+x.ylesanne.kysimusHTML()+"<td>"+\
            "<td>"+x.ylesanne.vaatamineHTML()+"</td>"+\
            "<td>"+x.marksonadHTML()+"</td>"+\
            "<td>"+x.selgitusHTML()+"</td>"+\
            "<td>"+x.ylesanne.meta_type+"</td></tr>"
        tulemus=tulemus+"</table>\n<br />"+self.marksonaViideteLoetelu()
        return tulemus


     def ylesandedMuutmisTabelina(self, REQUEST):
        "lesanded koos viidetega kustutamiseks ja muutmiseks"
        tulemus=leheAlgus(self, REQUEST)+\
        "<form action='kustuta_leht'><table>"
        for x in self.elemendidHoidlas():
          tulemus=tulemus+"\n<tr><td>"+x.ylesanne.kysimusHTML()+"<td>"+\
            "<td>"+x.ylesanne.vaatamineHTML()+"</td>"+\
            "<td>"+x.marksonadHTML()+"</td>"+\
            "<td>"+x.selgitusHTML()+"</td>"+\
            "<input type='checkbox' name='kustuta' value='"+x.id+"' />"+"</td>"+\
            "<td><a href='"+x.id+"/ylesanne/muutmisVorm'>lesanne</a><a href='"+x.id+"/kirjeldus/muutmisVorm'>Kirjeldus</a></td>"+\
            "</tr>"
        tulemus=tulemus+"</table><input type='submit' value='Kustuta' /></form>"+\
           "\n<br /><a href='ylesanneteTyypideLoetelu'>Lisa lesanne</a>"
        return tulemus
        
     def kustuta_leht(self, REQUEST, kustuta=None):
        "lesannete kustutamise leht"
        if kustuta is None:
           kustuta=()
        if type(kustuta) is types.StringType:
           kustuta=(kustuta,)
        for x in kustuta:
           self._delObject(x)
        REQUEST.RESPONSE.redirect('ylesandedMuutmisTabelina')
        
        
     def ylesanneteTyypideLoetelu(self, REQUEST):
        "Vljakutse"
        return leheAlgus(self, REQUEST)+TestiYlesanne().ylesanneteTyypideLoetelu()
        
     def lisaUusYlesanne(self, REQUEST, tyyp):
        "lesande lisamine" 
        yl=TestiYlesanne().lisaUusYlesanne(tyyp)
        self.lisaYlesanne(yl)
        REQUEST.RESPONSE.redirect('ylesandedMuutmisTabelina')
        
     def leivaPuru(self, viimane=0):
        "Teekond les"
        nimi="lesannete hoidla"
        if viimane:
          tekst=nimi
        else:
          tekst="<a href='"+self.absolute_url()+"'">nimi+"</a>"
        return " &gt; "+tekst
                          
     def index_html(self, REQUEST):
        "Peegel veebis"
        return self.ylesandedTabelina(REQUEST)
        
                
     
class ValikYlesanne(TestiYlesanne):
    "Valikvastustega lesanne"
    meta_type='ValikYlesanne'
    security=ClassSecurityInfo()
    security.declareObjectPublic()
    vastus=1
 
    def __init__(self, uuskysimus, uusvastus=1):
        """
        """
        self.kysimus=uuskysimus
        if self.sobivuskontroll(uusvastus):
          self.vastus=uusvastus # kas 0 vi 1
        else:
          raise Exception("sobimatu vastus")
          
    def sobivuskontroll(self, valik):
       if valik==0 or valik==1:
          return 1
       else:
          return 0
        
    def annaKysimus(self):
        return self.kysimus
        
        
    def taitmineHTML(self, elemendinimi):
        "Vastuse sisestamise koht"
        return "<input type='checkbox' name='%s' />" % elemendinimi
        
    def vaatamineHTML(self):
        "Koostaja poolt lahenduskoha vaatamine"
        if self.vastus:
          return "+"
        else:
          return "-"
          
    def tegelikHTML(self):
       "Opetaja lahendus"
       return self.vaatamineHTML()
          
    def pakutudHTML(self):
       "Pakutud andmete esitus veebis"
       if self.vastusPakutud:
        if self.pakutudAndmed=="on":
          return "+"
        else:
          return "-"
       else:
        return "Vastus salvestamata"

    def kasPihtasArvutus(self):
       "Ylekate"
       return 1

    def kasPihtas(self):
       "uuring"
       arv=0
       if self.pakutudAndmed=="on":
         arv=1
       if arv==self.vastus:
         return 1
       else:
         return 0

          
    def vastuseMuutmisVorm(self):
        "le kaetud, nitab vastusevaliku mrkeruudu"
        olek=""
        if self.vastus:
           olek=" CHECKED "
        return "<input type='checkbox' name='vastus' "+olek+"/>"
        
    def vastuseMuutmisLeht(self, vastus):
        "Vastuse salvestamine, le kaetud"
        if vastus is not None:
          self.vastus=1
        else:
          self.vastus=0
          
    def koopia(self):
       "Koopia lesandest"
       t=ValikYlesanne(self.kysimus, self.vastus)
       return t
       
       
class TekstivastusegaYlesanne(TestiYlesanne):
    "Tekstivastustega lesanne"
    meta_type='TekstivastusegaYlesanne'
    security=ClassSecurityInfo()
    security.declareObjectPublic()
 
    def __init__(self, uuskysimus):
        """
        """
        self.kysimus=uuskysimus
        
        
    def taitmineHTML(self, elemendinimi):
        "Vastuse sisestamise koht"
        return "<textarea name='%s' /></textarea>" % elemendinimi
        
    def vaatamineHTML(self):
        "Koostaja poolt lahenduskoha vaatamine"
        return "..."
          
    def pakutudHTML(self):
        "Pakutud andmete esitus veebis"
        if self.vastusPakutud:
          return asendaHTML(str(self.pakutudAndmed))
        else:
          return "Vastus puudub"
          
    def tegelikHTML(self):
        "Opetaja vastus"
        return "Igal oma vastus"
          
    def vastuseMuutmisVorm(self):
        "le kaetud, vastust ei saa ette mrata"
        return "..."       
        
          
    def koopia(self):
       "Koopia lesandest"
       t=TekstivastusegaYlesanne(self.kysimus)
       return t
    


class YksikvalikYlesanne(TestiYlesanne):
    "ksiku valikuga lesanne"
    meta_type='YksikvalikYlesanne'
    security=ClassSecurityInfo()
    security.declareObjectPublic()
 
    def __init__(self, uuskysimus):
        "Loomine"
        self.kysimus=uuskysimus
        self.valikud=[]
        self.oigeValik=-1
        
        
    def taitmineHTML(self, elemendinimi):
        "Vastuse sisestamise koht"
        tulemus="<table>"
        if len(self.valikud)>0:
         for i in range(len(self.valikud)):
          tulemus=tulemus+"\n<tr>"+\
            "<td>"+asendaHTML(self.valikud[i])+"</td>"+\
            "<td><input type='radio' name='"+elemendinimi+"' "+\
            "value='"+str(i)+"'></td></tr>"
         tulemus=tulemus+"</table>"
        else:
         tulemus="Valikud puuduvad"
        return tulemus
        
    def tegelikHTML(self):
       "Opetaja pakutu"
       if self.oigeValik==-1:
         return "Lahendus puudub"
       return self.valikud[self.oigeValik]

        
    def vaatamineHTML(self):
        "Koostaja poolt lahenduskoha vaatamine"
        tulemus=""
        if len(self.valikud)>0:
          tulemus=tulemus+"<ul>"
          for x in self.valikud:
            tulemus=tulemus+"\n<li>"+asendaHTML(x)+"</li>"
          tulemus=tulemus+"</ul>"
        else:
          tulemus="Valikud puuduvad"
        return tulemus
        
        
    def pakutudHTML(self):
        "Pakutud andmete esitus veebis"
        if self.vastusPakutud:
          if self.pakutudAndmed is None:
            return "Vastus valimata"
          try:
            return asendaHTML(self.valikud[int(self.pakutudAndmed)])
          except:
            return "Probleem andmetega"          

    def kasPihtasArvutus(self):
        "Ylekate"
        return 1

    def kasPihtas(self):
        "Arvutus ise"
        try:
          return int(self.pakutudAndmed)==self.oigeValik
        except:
          return 0

    def vastuseMuutmisVorm(self):
        "le kaetud, lubab muuta variante ja vastust"
        tulemus="<table>"
        for i in range(len(self.valikud)):
          margitud=""
          if i==self.oigeValik:
            margitud="CHECKED"
          tulemus=tulemus+"\n<tr>"+\
            "<td><input type='text' name='vastus' value='"+asendaHTML(self.valikud[i])+"'></td>"+\
            "<td><input type='radio' name='valikunr' "+\
            "value='"+str(i)+"' "+margitud+"></td></tr>"
        tulemus=tulemus+"<tr><td><input type='text' name='vastus' /></td>"+\
                "<td><input type='radio' name='valikunr' value='"+str(len(self.valikud))+"'></td></tr>"
        if len(self.valikud)==0:
          tulemus=tulemus+"<tr><td><input type='text' name='vastus' /></td>"+\
                "<td><input type='radio' name='valikunr' value='1'></td></tr>"

        tulemus=tulemus+"</table>"
        return tulemus
        
    def muutmisLeht(self, REQUEST=None, kysimus="", vastus="", valikunr=-1):
        "Vastuse salvestamine, le kaetud"
        self.kysimus=kysimus 
        if vastus is None:
          vastus=()
        if type(vastus) is types.StringType:
          vastus=(vastus,) 
        valikunr=int(valikunr)         
        self.valikud=[]
        for i in range(len(vastus)):
          if len(vastus[i])>0:
            self.valikud.append(vastus[i])
          else:
            if valikunr==i:
              valikunr=-1
            if valikunr>i:
              valikunr=valikunr-1
        self.oigeValik=valikunr
        REQUEST.RESPONSE.redirect('muutmisVorm')
          
    def koopia(self):
       "Koopia lesandest"
       t=YksikvalikYlesanne(self.kysimus)
       for x in self.valikud:
         t.valikud.append(x)
       t.oigeValik=self.oigeValik
       return t



class YlTest(
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
    "lesannetest koosnev test"
    meta_type='YlTest'
    pealkiri="Test"
    nr=0
    avatudTaitmiseks=0
    security=ClassSecurityInfo()
    security.declareObjectPublic()
    
    
      
    def lisaYlesanne(self, yl):
       "uus lesanne testis"
       self.nr=self.nr+1
       yl.id="yl"+str(self.nr)
       self._setObject(yl.id, yl)
       
    def kysimused(self):
       "Ksimuste loetelu"
       k=[]
       for x in self.ylesanded():
         k.append(x.kysimus)
       return k
       
    def ylesanded(self):
       "lesannete loetelu"
       return self.objectValues()
     
    def pealkiri(self):
       "Testi nimi"
       return self.pealkiri    
       
       
    def ylesanneteArv(self):
       "lesannete arv"
       return len(self.ylesanded())
       
    def tutvustus(self):
       "Testi tutvutus"
       return "Lahendamiseks meldud test"

    def kasAvatudTaitmiseks(self):
       "Teatab, kas opilastele on test nahtav"
       try:
         return self.avatudTaitmiseks
       except:
         return 0

    def seaAvatudTaitmiseks(self, seisund, REQUEST):
       "Saab oelda, kas avatud"
       if seisund=="1":
         self.avatudTaitmiseks=1
       else: 
         self.avatudTaitmiseks=0
       #return str(self.avatudTaitmiseks)
       REQUEST.RESPONSE.redirect('index_html')
       
    def ylesanneteTyypideLoetelu(self, REQUEST):
        "Vljakutse"
        return leheAlgus(self, REQUEST)+TestiYlesanne().ylesanneteTyypideLoetelu()
        
    def lisaUusYlesanne(self, REQUEST, tyyp):
        "lesande lisamine" 
        yl=TestiYlesanne().lisaUusYlesanne(tyyp)
        self.lisaYlesanne(yl)
        REQUEST.RESPONSE.redirect('ylesandedMuutmisTabelina')

    def ylesandedTabelina(self, REQUEST):
        "lesanded tabelina"
        m=self.ylesanded()
        tulemus=leheAlgus(self, REQUEST)+"<table>"
        for x in m:
          tulemus=tulemus+"\n<tr><td>"+x.kysimusHTML()+"<td>"+\
            "<td>"+x.vaatamineHTML()+"</td>"+\
            "<td>"+x.marksonadHTML()+"</td>"+\
            "<td>"+x.ylesanne.meta_type+"</td></tr>"
        tulemus=tulemus+"</table>"
        return tulemus


    def ylesandedMuutmisTabelina(self, REQUEST):
        "lesanded koos viidetega kustutamiseks ja muutmiseks"
        tulemus=leheAlgus(self, REQUEST)
        if len(self.ylesanded())>0:        
         tulemus=tulemus+"<form action='kustuta_leht'><table>"+\
          "<tr><td>Kysimus</td><td>Vastus</td><td>Tyyp</td><td>Kustutus</td><td>Muutus</td></tr>"
         for x in self.ylesanded():
          tulemus=tulemus+"\n<tr><td>"+x.kysimusHTML()+"</td>"+\
            "<td>"+x.vaatamineHTML()+"</td>"+\
            "<td>"+x.meta_type+"</td>"+\
            "<td><input type='checkbox' name='kustuta' value='"+x.id+"' />"+"</td>"+\
            "<td><a href='"+x.id+"/muutmisVorm'>muuda</a></td>"+\
            "</tr>"
         tulemus=tulemus+"</table><input type='submit' value='Kustuta' /></form>"+\
           "\n<br />"
        avatuArv=1
        avatuTekst="Avalikusta"
        if self.avatudTaitmiseks:
          avatuArv=0
          avatuTekst="Peida"
        tulemus=tulemus+"<a href='ylesanneteTyypideLoetelu'>Lisa Ylesanne</a>"+\
          "<br /><a href='seaAvatudTaitmiseks?seisund="+str(avatuArv)+"'>"+avatuTekst+" test</a>"+\
          "<br /><a href='kasutajateTulemused'>Kasutajate lahendused</a><br />"
        return tulemus
        


    def kustuta_leht(self, REQUEST, kustuta=None):
        "lesannete kustutamise leht"
        if kustuta is None:
           kustuta=()
        if type(kustuta) is types.StringType:
           kustuta=(kustuta,)
        for x in kustuta:
           self._delObject(x)
        REQUEST.RESPONSE.redirect('ylesandedMuutmisTabelina')
        
    def ylTyyp(self, ylid):
       "Ksitud ID-ga lesande tp"
       if hasattr(self, ylid):
         return self.ylid.meta_type
       return None

       
    def taidaVorm(self, REQUEST):
       "Titmisvorm"
       tulemus=leheAlgus(self, REQUEST)+"""
         <h3>Testi lahendamine</h3>
         <form action="loeAndmedLehelt">
           <table>
       """
       for x in self.ylesanded():
            tulemus=tulemus+"\n<tr><td>"+x.kysimusHTML()+"</td>"+\
            "<td>"+x.taitmineHTML(x.id) + "</td></tr>"
       tulemus=tulemus+"""
               </table>
               <input type="submit" value="Salvesta" />
               </form>
               """
       return tulemus
       
    def index_html(self, REQUEST):
       "Peegel veebi"
       if self.kas_opetaja(self, REQUEST):
         #return self.ylesandedMuutmisTabelina(REQUEST)
         REQUEST.RESPONSE.redirect(self.absolute_url()+"/ylesandedMuutmisTabelina")
       else:
         return self.taidaVorm(REQUEST)


    def loeAndmedLehelt(self, REQUEST, **elemendid):
        "Veebilt tulevad andmed talde"
        tulemus=""
        t=TestiVastused()
        t.testinimi=self.id
        for x in self.ylesanded():
          vastus=None
          if hasattr(REQUEST, x.id):
            vastus=getattr(REQUEST, x.id)
          tulemus=tulemus+"!"+x.id+" "+str(vastus)
          t._setObject(x.id, x.salvestaPakutu(vastus))
        self.paigutaTestiVastus(REQUEST, t)
        return leheAlgus(self, REQUEST)+"andmed salvestatud"
        
  #  def salvestusAsukoht(self, REQUEST, testinimi='nimetu'):
  #     "Koht testi tulemuste salvestamiseks"
  #     kasutaja=getattr(getattr(self.fle_root().fle_users, str(REQUEST.AUTHENTICATED_USER)).webtop, 'wt5')
  #     if not hasattr(kasutaja, 'testid'):
  #        kasutaja.manage_addProduct['OFSP'].manage_addFolder('testid')
  #        #kasutaja._setObject('testid', TestiVastused())
  #     if not hasattr(kasutaja.testid, testinimi):
  #        kasutaja.testid.manage_addProduct['OFSP'].manage_addFolder(testinimi)
  #        testikataloog=getattr(kasutaja.testid, testinimi)
  #        testikataloog.variandinr=0
  #     testikataloog=getattr(kasutaja.testid, testinimi)
  #     #return self.get_url_to_object(testikataloog)
  #     return testikataloog
  

    def salvestusAsukoht(self, REQUEST, testinimi='nimetu'):
       "Koht testi tulemuste salvestamiseks"
       kasutajajuur=getattr(self.fle_root().fle_users,\
                   str(REQUEST.AUTHENTICATED_USER))
       try:
        kasutaja=getattr(kasutajajuur.webtop,\
          'c'+kasutajajuur.get_jooksev_kursus())
       except:
        kasutaja=kasutajajuur.webtop
       if not hasattr(kasutaja, 'testivastused'):
          kasutaja.manage_addProduct['OFSP'].manage_addFolder('testivastused')
          kasutaja.testivastused.id='testivastused'
       if not hasattr(kasutaja.testivastused, testinimi):
          kasutaja.testivastused.manage_addProduct['OFSP'].manage_addFolder(testinimi)
          testikataloog=getattr(kasutaja.testivastused, testinimi)
          testikataloog.id=testinimi
          testikataloog.variandinr=0
       testikataloog=getattr(kasutaja.testivastused, testinimi)
       #return self.get_url_to_object(testikataloog)
       return testikataloog

    def paigutaTestiVastus(self, REQUEST, vastus):
       "Paigutab variandi uue id alla"
       k=self.salvestusAsukoht(REQUEST, vastus.testinimi)
       k.variandinr=k.variandinr+1
       vastus.id="variant"+str(k.variandinr)
       k._setObject(vastus.id, vastus)
       return str(k.variandinr)

    def kasutajateTulemused(self, REQUEST):
       "Testi tulemused"
       tulemus=leheAlgus(self, REQUEST)+"<h3>Lahendused</h3><ul>"
       try:
         kasutajad=self.get_all_users()
       except:
         return tulemus+"probleem kasutajate leidmisel"
       for x in kasutajad:
         tulemus=tulemus+"<li>"+x.id+"</li>"
         try:
           k=getattr(x.webtop, 'c'+str(self.find_course().get_id()))
           #tulemus=tulemus+"j"+k.absolute_url()
           if hasattr(k, 'testivastused'):
             #tulemus=tulemus+"k"
             if hasattr(k.testivastused, self.id):               
               t=getattr(k.testivastused, self.id)
               tulemus=tulemus+"<ul>"
               for y in t.objectValues():
                 tulemus=tulemus+"<li><a href='"+y.absolute_url()+"'>"+y.id+"</a> "+str(y.pihtasSumma())+"</li>"
               tulemus=tulemus+"</ul>"
         except:
           tulemus=tulemus+"?"
       return tulemus+"</ul>"


  
       
    def leivaPuru(self, viimane=0):
       "Teekond les"
       nimi=self.id
       if viimane:
         tekst=nimi
       else:
         tekst="<a href='"+self.absolute_url()+"'>"+nimi+"</a>"
       return " &gt; " + tekst
       
#    def paigutaTestiVastus(self, REQUEST, vastus):
#       "Paigutab variandi uue id alla"
#       k=self.salvestusAsukoht(REQUEST, vastus.id)
#       k.variandinr=k.variandinr+1
#       #vastus=ValikTest()
#       k._setObject("variant"+str(k.variandinr), vastus)
#       return str(k.variandinr)

Globals.default__class_init__(YlTest)



class TestiVastused(
     OFS.Folder.Folder,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):           
     "Testi vastusvariant"
     testinimi=""
     
     def ylesanded(self):
       "lesannete kogum"
       return self.objectValues()
     
     
     def vastusteTabel(self, REQUEST):
       "lesannete vastused tabelina"
       tulemus=leheAlgus(self, REQUEST)+"<table>"+\
         "<tr><td>K&uuml;simus</td><td>Pakuti</td><td>&Otilde;petaja lahendus</td><td>Tabamus</td></tr>"
       for x in self.ylesanded():
          tulemus=tulemus+"\n<tr><td>"+x.kysimusHTML()+"</td><td>"+\
          x.pakutudHTML()+"</td><td>"+x.tegelikHTML()+"</td><td>"+x.kasPihtasHTML()+"</td></tr>"
       tulemus=tulemus+"</table>"
       return tulemus


     def pihtasSumma(self):
       "Tabamusega ylesannete summa"
       summa=0
       for x in self.ylesanded():
         if x.kasPihtas():
           summa=summa+1
       return summa

       
     def leivaPuru(self, viimane=0):
       "Teekond les"
       nimi="Testi "+self.testinimi+" vastused"
       if viimane:
         tekst=nimi
       else:
         tekst="<a href='"+self.absolute_url()+"'>"+nimi+"</a>"
       return " &gt; "+tekst
       
     def index_html(self, REQUEST):
       "Peegel veebi"
       return self.vastusteTabel(REQUEST)
       
   

class ValikYlesandeVastus(ValikYlesanne):
    "Valikvastustega lesande vastus"
    meta_type='ValikYlesandeVastus'
    security=ClassSecurityInfo()
    security.declareObjectPublic()

    def __init__(self, uuskysimus, uusvastus, uuspakutu):
       ""
       ValikYlesanne.__init__(self, uuskysimus, uusvastus)
       if self.sobivuskontroll(uuspakutu):
         self.pakutu=uuspakutu
       else:
         raise Exception("sobimatu pakutu")
          
    def annaPakutu(self):
        if hasattr(self, pakutu):
           return self.pakutu
        else:
           return -1
 
    def kasPihtas(self):
        return self.pakutu==self.vastus

class ValikTestiVastus(
     OFS.Folder.Folder,
     Persistent,
     AccessControl.Role.RoleManager):
     "jah/ei testi vastused"
     meta_type='ValikTestiVastus'
    
     
     def loeAndmed(self, test, pakutud):
        "Andmed koos pakututega talde"
        self.vastused=[]
        yl=test.ylesanded()
        for nr in range(len(yl)):
          sees=0
          if str(nr) in pakutud:
            sees=1
          self.vastused.append(ValikYlesandeVastus(yl[nr].kysimus, yl[nr].vastus, sees))
        self.vastused=self.vastused
          
     def kokkuPihtas(self):
        "Tabamuste arv"
        kokku=0
        for x in self.vastused:
           if x.kasPihtas():
              kokku=kokku+1
        return kokku
        
     def pihtasProtsent(self):
        return self.kokkuPihtas()*100/len(vastused)
        
     def tulemusteTabel(self):
        "Vastuste tabel"
        tulemus="""
          <table>
            <tr>
              <td>Ksimus</td>
              <td>ige vastus</td>
              <td>Pakutud</td>
              <td>Kas pihtas</td>
            </tr>
        """
        for x in self.vastused:
          vastus="-"
          pakutu="-"
          korras="-"
          if x.vastus: vastus="+"
          if x.kasPihtas(): korras="+"
          if x.pakutu: pakutu="+"
          tulemus=tulemus+("\n<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>"%
              (x.kysimus, vastus, pakutu, korras))
        tulemus=tulemus+"</table>"      
        return tulemus   
        
     def pyyaFail(self, fail):
          "faili pyydmine"
          #return str(dir(fail))
          return str(fail.readlines()) + fail.readline() + str(dir(fail))
          #seisfail=OFS.Image.File("Kala", "Juur", fail)
          #return "leiti" + seisfail.data+ str(type(3))       


def asendaHTML(sona):
   try:
    sona=sona.replace("&", "&amp;")
    sona=sona.replace(">", "&gt;")          
    sona=sona.replace("<", "&lt;")             
    return sona;
   except:
    return "kala: "+sona
           
def leheAlgus(obj, REQUEST):
   return obj.hdr(obj, REQUEST)+obj.leivaPuru()+"<br />"